/*
 * ACB-BF592 UMB-SSM2603 IIRtB^R[h Visual DSP++p
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * Last Update: 2013/03/19
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 * 2o^[[X^[pXtB^AJbgItg1KHzŃtB^Ă܂B
 * y𗬂ƁAL悪JbgĒቹȂɕς܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <sys/exception.h>
#include <filter.h>
#include <stdint.h>
#include <string.h>

/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)

#define TWI_COUNT(x) (DCNT & ((x) << 6))
/* TWIp߂l */
#define NO_ERROR		(0)
#define TWI_ERROR_NAK	(-1)
/* s_twi_master_writerstartp` */
#define TWI_STOP		(0)
#define TWI_RSTART		(1)

/* SSM2603I2CfoCXAhX */
#define TWI_DEVICE_ADDR	(0x1A)

/* 1̃TvTCY */
#define NUM_SAMPLES		(256)

/* SPORT RX DMA荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_sport_rx_isr);
/* I[fBIp֐ */
void s_audio_process(const int32_t* p_rxbuf, int32_t* p_txbuf, int32_t count);

/* TWI(I2C)p֐ */
void s_twi_init(void);
/* TWI(I2C)f[^Mp֐ */
int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt);

/* SPORTMobt@(_uobt@) */
static int32_t sf_sport_rxbuf[2][NUM_SAMPLES];
/* SPORTMobt@(_uobt@) */
static int32_t sf_sport_txbuf[2][NUM_SAMPLES];
/* DMAǂ̃obt@gpĂ邩 */
static volatile int32_t sf_sport_use_bufidx;

/* f[^]tO */
static volatile int32_t sf_data_incoming;

/* SSM2603 TWIf[^ */
static const uint8_t sf_audio_init_data[] =
{
	(0x0F << 1) | 0, 0x00,
	(0x00 << 1) | 1, 0x17,
	(0x01 << 1) | 1, 0x17,
	(0x02 << 1) | 1, 0x79,
	(0x03 << 1) | 1, 0x79,
	(0x04 << 1) | 0, 0x12,
	(0x05 << 1) | 0, 0x00,
	(0x06 << 1) | 0, 0x02,
	(0x07 << 1) | 0, 0x4E,
	(0x08 << 1) | 0, 0x00,
	(0x09 << 1) | 0, 0x01,
	(0x10 << 1) | 1, 0x8B,
	(0x12 << 1) | 0, 0x03,
};

/* IIRtB^̌W */
/* Butterworth LPF
   Sampling Frequency =   48000.0
   cutoff1 =    1000.0
   Order = 2nd */
static const long double sf_iir_bcoeffs[] =
{
	/* b0 */  0.00392500579,
	/* b1 */  0.00785001159,
	/* b2 */  0.00392500579,
};
static const long double sf_iir_acoeffs[] =
{
	/* a1 */ -1.81512337207,
	/* a2 */  0.83082339524,
};
/* iirdf1_fr32p[NGA` */
static iirdf1_state_fr32 sf_iir_state;
static fract32           sf_iir_coeffs[4 + 2];
static fract32           sf_iir_delay[4 + 2];


static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
	uint32_t l_start;
	uint32_t l_now;
	int32_t l_stop = us * (1000 / 2.5);	/* 1 cycle = 2.5ns */

	asm("%0 = CYCLES;" : "=d"(l_start));
	while(1)
	{
		asm volatile("%0 = CYCLES;" : "=d"(l_now));
		if((l_now - l_start) >= l_stop)
			break;
	}
}

void main(void)
{
	uint32_t l_lc;
	int32_t  l_dmabuf_idx;
	
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);
	
	/* obt@NA */
	memset(sf_sport_rxbuf, 0 , sizeof(sf_sport_rxbuf));
	memset(sf_sport_txbuf, 0 , sizeof(sf_sport_txbuf));
	sf_sport_use_bufidx = 0;
	sf_data_incoming = 0;
	
	/* IIRtB^̐ݒ */
	memset(sf_iir_delay, 0, sizeof(sf_iir_delay));
	coeff_iirdf1_fr32(sf_iir_acoeffs, sf_iir_bcoeffs, sf_iir_coeffs, 1);
	iirdf1_init(sf_iir_state, sf_iir_coeffs, sf_iir_delay, 1);
	
	/* |[g̐ݒ */
	*pPORTF_MUX &= ~(PF1 | PF2 | PF3 | PF5 | PF6 | PF7); 
	*pPORTF_FER |= PF1 | PF2 | PF3 | PF5 | PF6 | PF7;
	/* MUTEsݒ (PF4Ɋ蓖ĂĂꍇ) */
	*pPORTFIO_CLEAR = PF4;
	*pPORTFIO_DIR |= PF4;

	/* TWI */
	s_twi_init();
	/* SSM2603 */
	for(l_lc = 0; l_lc < sizeof(sf_audio_init_data); l_lc += 2)
	{
		/* SSM2603WX^ݒ */
		s_twi_master_write(TWI_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data[l_lc], 2);
		s_us_delay(10000); /* 莞ԑҋ@ (̎ԂZƂ܂ZbgȂP[X)*/
	}

	/* SPORT RX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_RCR1 = RFSR | RCKFE;
	*pSPORT1_RCR2 = SLEN(31) | RSFSE;
	/* SPORT TX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_TCR1 = TFSR | TCKFE;
	*pSPORT1_TCR2 = SLEN(31) | TSFSE;

	/* DMA3(SPORT1 RX)̐ݒ */
	*pDMA3_PERIPHERAL_MAP = 0x3000;
	*pDMA3_CONFIG = FLOW_AUTO | DI_EN | DI_SEL | DMA2D | WDSIZE_32 | WNR;
	*pDMA3_START_ADDR = sf_sport_rxbuf;
	*pDMA3_X_COUNT = NUM_SAMPLES;
	*pDMA3_X_MODIFY = sizeof(int32_t);
	*pDMA3_Y_COUNT = 2;
	*pDMA3_Y_MODIFY = sizeof(int32_t);

	/* DMA4(SPORT1 TX)̐ݒ */
	*pDMA4_PERIPHERAL_MAP = 0x4000;
	*pDMA4_CONFIG = FLOW_AUTO | DMA2D | WDSIZE_32;
	*pDMA4_START_ADDR = sf_sport_txbuf;
	*pDMA4_X_COUNT = NUM_SAMPLES;
	*pDMA4_X_MODIFY = sizeof(int32_t);
	*pDMA4_Y_COUNT = 2;
	*pDMA4_Y_MODIFY = sizeof(int32_t);
	ssync();

	/* 荞݃nhIVG9ɓo^ */
    register_handler(ik_ivg9, s_sport_rx_isr);
	*pSIC_IMASK |= IRQ_DMA3;

	/* DMAL */
	*pDMA3_IRQ_STATUS = DMA_DONE;
	*pDMA3_CONFIG |= DMAEN;
	*pDMA4_CONFIG |= DMAEN;
	/* SPORT1L */
	*pSPORT1_TCR1 |= TSPEN;
	*pSPORT1_RCR1 |= RSPEN;
	ssync();
	
	/* MUTE */
	*pPORTFIO_SET = PF4;

	while(1)
	{
		idle();
		if(0 != sf_data_incoming)
		{
			/* tONA */
			sf_data_incoming = 0;
			/* gpĂ悢obt@擾 */
			l_dmabuf_idx = sf_sport_use_bufidx ^ 1;
			s_audio_process(sf_sport_rxbuf[l_dmabuf_idx], sf_sport_txbuf[l_dmabuf_idx], NUM_SAMPLES);
		}
	}
}

void s_audio_process(const int32_t* p_rxbuf, int32_t* p_txbuf, int32_t count)
{
	/* IIRtB^K */
	iirdf1_fr32((const fract32*)p_rxbuf, (fract32*)p_txbuf, count, &sf_iir_state);
}

/* SPORT RX DMA荞݃nh */
EX_INTERRUPT_HANDLER(s_sport_rx_isr)
{
	*pDMA3_IRQ_STATUS = DMA_DONE;
	ssync();
	/* I[fBIR[fbNf[^ */
	sf_data_incoming = 1;
	/* DMAgpobt@ύX */
	sf_sport_use_bufidx = (sf_sport_use_bufidx ^ 1) & 1;
}

/* TWI(I2C) */
void s_twi_init(void)
{
	*pTWI_CONTROL = 0;
	ssync();
	*pTWI_CONTROL = TWI_ENA | 10U;
	*pTWI_CLKDIV  = CLKHI(50) | CLKLOW(50);
	*pTWI_INT_MASK = RCVSERV | XMTSERV | MERR | MCOMP;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;
	ssync();
}

int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt)
{
	int32_t l_idx;
	
	if(write_cnt <= 0)
	{
		return NO_ERROR;
	}

	*pTWI_FIFO_CTL = 0;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_MASTER_STAT = BUFWRERR | BUFRDERR | LOSTARB | ANAK | DNAK;
	*pTWI_MASTER_ADDR = slave_addr;
	// Send first byte
	*pTWI_XMT_DATA8 = p_data[0];
	*pTWI_MASTER_CTL = TWI_COUNT(write_cnt) | MEN | (rstart ? RSTART : 0);
	ssync();

	for(l_idx = 1; l_idx < write_cnt; l_idx++)
	{
		while(((*pTWI_INT_STAT & MERR) == 0U) && (*pTWI_FIFO_STAT == XMTSTAT)) ssync();
		*pTWI_XMT_DATA8 = p_data[l_idx];
		ssync();
	}

	/* ]I܂őҋ@ */
	while((*pTWI_INT_STAT & MCOMP) == 0U) ssync();
	if((*pTWI_INT_STAT & MERR) == 0U)
	{
		return NO_ERROR;
	}
	else
	{
		return TWI_ERROR_NAK;
	}
}
